unit ESBProducts;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBISAMTb, Db, StdCtrls, DBCtrls, Mask, ESBPCSLabel,
  ESBPCSDbEdit, ESBPCSDbNumEdit, ESBPCSDbCurrCalcEdit, ESBPCSPanel,
  ESBPCSDBSpinEdit, Buttons, ESBPCSCheckBox, ESBPCSDbCheckBox;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    DBISAMDatabase1: TDBISAMDatabase;
    tblProduct: TDBISAMTable;
    tblProductProductName: TStringField;
    tblProductProductUPC: TStringField;
    tblProductQtyOnHand: TIntegerField;
    tblProductEOQ: TIntegerField;
    tblProductCostPrice: TCurrencyField;
    tblProductMarkUp: TFloatField;
    tblProductSellPrice: TCurrencyField;
    tblProductSoldToDate: TIntegerField;
    tblProductAllowUpdates: TBooleanField;
    Label1: TLabel;
    dsProduct: TDataSource;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    DBCheckBox1: TESBDbCheckBox;
    DBNavigator1: TDBNavigator;
    ESBPCSLabel1: TESBPCSLabel;
    DBEdit1: TESBPCSDbEdit;
    DBEdit2: TESBPCSDbEdit;
    DBEdit3: TESBDBIntSpinEdit;
    DBEdit4: TESBDBIntSpinEdit;
    DBEdit8: TESBDBIntSpinEdit;
    DBEdit6: TESBDbPercentEdit;
    DBEdit5: TESBDbCurrencyCalcEdit;
    DBEdit7: TESBDbCurrencyCalcEdit;
    tblProductProductID: TAutoIncField;
    ESBPCSLabel2: TESBPCSLabel;
    SpeedButton1: TSpeedButton;
    procedure dsProductDataChange(Sender: TObject; Field: TField);
    procedure tblProductBeforeEdit(DataSet: TDataSet);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses AboutDialog;

{$R *.DFM}

procedure TForm1.dsProductDataChange(Sender: TObject; Field: TField);
Var
   i: Integer;
begin
          for I := 0 to ComponentCount - 1 do
         begin
            if  Components[I] is TESBPCSDBEdit then
            TESBPCSDBEdit(Components[I]).ReadOnly := tblProductAllowUpdates.Value;
             if  Components[I] is TESBDBIntSpinEdit then
            TESBDBIntSpinEdit(Components[I]).ReadOnly := tblProductAllowUpdates.Value;
              if  Components[I] is TESBDBCurrencyCalcEdit then
            TESBDBCurrencyCalcEdit(Components[I]).ReadOnly := tblProductAllowUpdates.Value;
             if  Components[I] is TESBDBPercentEdit then
            TESBDBPercentEdit(Components[I]).ReadOnly := tblProductAllowUpdates.Value;

         end;



end;

procedure TForm1.tblProductBeforeEdit(DataSet: TDataSet);
begin
if tblProductAllowUpdates.Value then
begin
MessageDlg('This product may not be modified.  Please contact your '+#13+#10+'department adminstrator.', mtInformation, [mbOK], 0);
Abort;
end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 Application.CreateForm(TDlgAbout, DlgAbout);
 DlgAbout.ShowModal;
 DlgAbout.Release;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
tblProduct.Open;
end;

end.
