unit affiliatemain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Buttons, DBISAMTb, Db, ComCtrls, StdCtrls, Mask,
  ESBPCSDbComboBox, ESBPCSDbEdit, ESBPCSLabel, ESBPCSUrlLabel,
  ESBPCSDbDateTimeEdit, ESBPCSDbNumEdit, ESBPCSPanel, ESBPCSDbCurrCalcEdit,
  ESBPCSDbDateTimeSpinEdit, ESBPCSDBSpinEdit, ESBPCSDateTimeLabel,
  ESBPCSButtons, ESBPCSDbCountryComboBox, ESBPCSDbLabel, ESBPCSDbUrlLabel,
  ESBPCSCheckBox, ESBPCSDbCheckBox, ESBPCSCalendar, ESBPCSDbCalEdit,
  ESBPCSCalculator;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    SpeedButton1: TSpeedButton;
    DBISAMDatabase1: TDBISAMDatabase;
    tblAffiliate: TDBISAMTable;
    dsAffiliate: TDataSource;
    tblAffiliateContactID: TAutoIncField;
    tblAffiliateTitle: TStringField;
    tblAffiliateFirstName: TStringField;
    tblAffiliateLastName: TStringField;
    tblAffiliateTelephone: TStringField;
    tblAffiliateEmailAddress: TStringField;
    tblAffiliateWebSite: TStringField;
    tblAffiliateBirthday: TDateField;
    tblAffiliateDateOnFile: TDateField;
    tblAffiliateLastUpdated: TDateField;
    tblAffiliateCommisionPercentage: TFloatField;
    tblAffiliateCommissionOwing: TCurrencyField;
    tblAffiliateForMonth: TIntegerField;
    tblAffiliateForDay: TIntegerField;
    tblAffiliateForYear: TIntegerField;
    tblAffiliateProductSold: TIntegerField;
    tblAffiliateAccountDisabled: TBooleanField;
    DBCheckBox1: TESBDbCheckBox;
    ESBDBComboBox1: TESBDBComboBox;
    DBEdit2: TESBPCSDbEdit;
    DBEdit3: TESBPCSDbEdit;
    DBEdit4: TESBPCSDbEdit;
    DBEdit5: TESBPCSDbEdit;
    DBEdit6: TESBPCSDbEdit;
    Label1: TESBPCSLabel;
    Label2: TESBPCSLabel;
    Label3: TESBPCSLabel;
    Label4: TESBPCSLabel;
    Label5: TESBPCSLabel;
    Label6: TESBPCSLabel;
    Label7: TESBPCSLabel;
    Label8: TESBPCSLabel;
    Label9: TESBPCSLabel;
    Label10: TESBPCSLabel;
    Label11: TESBPCSLabel;
    Label12: TESBPCSLabel;
    Label13: TESBPCSLabel;
    Label14: TESBPCSLabel;
    Label15: TESBPCSLabel;
    DBEdit7: TESBDbCalEdit;
    DBEdit8: TESBDbDateEdit;
    DBEdit9: TESBDbDateEdit;
    DBEdit10: TESBDbPercentEdit;
    tblAffiliateQtySold: TIntegerField;
    ESBPCSLabel1: TESBPCSLabel;
    ESBPCSLabel2: TESBPCSLabel;
    ESBUrlLabel3: TESBUrlLabel;
    ESBPCSLabel3: TESBPCSLabel;
    ESBSpeedBtn1: TESBSpeedBtn;
    ColorDialog1: TColorDialog;
    ESBPCSLabel4: TESBPCSLabel;
    ESBPCSLabel5: TESBPCSLabel;
    ESBSpeedBtn2: TESBSpeedBtn;
    ESBPCSLabel6: TESBPCSLabel;
    ESBPCSLabel7: TESBPCSLabel;
    ESBPCSLabel8: TESBPCSLabel;
    ESBDbCountryComboBox1: TESBDbCountryComboBox;
    tblAffiliateCountry: TStringField;
    ESBPCSLabel9: TESBPCSLabel;
    dbedit11: TESBDbCurrencyCalcEdit;
    DBEdit13: TESBDBDOWSpinEdit;
    DBEdit14: TESBDBYearSpinEdit;
    DBEdit15: TESBDBIntSpinEdit;
    DBEdit12: TESBDBMonthSpinEdit;
    ESBDbUrlLabel1: TESBDbUrlLabel;
    ESBDbUrlLabel2: TESBDbUrlLabel;
    ESBCalendar1: TESBCalendar;
    ESBCalculator1: TESBCalculator;
    procedure SpeedButton1Click(Sender: TObject);
    procedure tblAffiliateBeforePost(DataSet: TDataSet);
    procedure dsAffiliateDataChange(Sender: TObject; Field: TField);
    procedure ESBSpeedBtn1Click(Sender: TObject);
    procedure ESBSpeedBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ExeDir: string;
  end;

var
  Form1: TForm1;

implementation

uses
	AboutDialog, ESBPCSFileIO, ESBPCSCountries;

{$R *.DFM}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
	Application.CreateForm(TDlgAbout, DlgAbout);
	DlgAbout.ShowModal;
	DlgAbout.Release;
end;

procedure TForm1.tblAffiliateBeforePost (DataSet: TDataSet);
begin
	tblAffiliateLastUpdated.Value := Date;
end;

procedure TForm1.dsAffiliateDataChange(Sender: TObject; Field: TField);
var
	I: Integer;
begin
	for I := 0 to ComponentCount - 1 do
	begin
		if Components[I] is TESBDbCustomEdit then
			TESBDbCustomEdit(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
		else if  Components[I] is TESBDBIntSpinEdit then
			TESBDBIntSpinEdit(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
		else if  Components[I] is TESBDBCurrencyCalcEdit then
			TESBDBCurrencyCalcEdit(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
		else if  Components[I] is TESBDBDOWSpinEdit then
			TESBDBDOWSpinEdit(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
		else if  Components[I] is TESBDBMonthSpinEdit then
			TESBDBMonthSpinEdit(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
		else if  Components[I] is TESBDBYearSpinEdit then
			TESBDBYearSpinEdit(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
		else if  Components[I] is TESBDbCustomComboBox then
			TESBDbCustomComboBox(Components[I]).ReadOnly := tblAffiliateAccountDisabled.Value
	end;

	ESBPCSLabel2.Visible := tblAffiliateAccountDisabled.Value;
	DBEdit9.ReadOnly := True;
	DBEdit8.ReadOnly := True;
end;

procedure TForm1.ESBSpeedBtn1Click(Sender: TObject);
begin
	ColorDialog1.Color := ESBDBComboBox1.ColorList;
	if ColorDialog1.Execute then
		ESBDBComboBox1.ColorList := ColorDialog1.Color;
end;

procedure TForm1.ESBSpeedBtn2Click(Sender: TObject);
var
	I: Integer;
begin
	ColorDialog1.Color := DBEdit2.ColorFocus;
	if ColorDialog1.Execute then
	begin
		for I := 0 to ComponentCount - 1 do
		begin
			if  Components[I] is TESBDbCustomEdit then
				TESBDbCustomEdit(Components[I]).ColorFocus := ColorDialog1.Color
			else if  Components[I] is TESBDBIntSpinEdit then
				TESBDBIntSpinEdit(Components[I]).ColorFocus := ColorDialog1.Color
			else if  Components[I] is TESBDBCurrencyCalcEdit then
				TESBDBCurrencyCalcEdit(Components[I]).ColorFocus := ColorDialog1.Color
			else if  Components[I] is TESBDBDOWSpinEdit then
				TESBDBDOWSpinEdit(Components[I]).ColorFocus := ColorDialog1.Color
			else if  Components[I] is TESBDBMonthSpinEdit then
				TESBDBMonthSpinEdit(Components[I]).ColorFocus := ColorDialog1.Color
			else if  Components[I] is TESBDBYearSpinEdit then
				TESBDBYearSpinEdit(Components[I]).ColorFocus := ColorDialog1.Color;
		end;
	end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	ExeDir := ExtractFilePath (Application.ExeName);
	ReadCountryList (ESBCountryList, ExeDir + 'ESBCountry.xml');
	ESBDBCountryComboBox1.LoadItems;
	if tblAffiliate.Active then
		tblAffiliate.Active := False;
	tblAffiliate.Open;
end;

end.
